/*
 * This routine creates the socket and sets some options
 */

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <string.h>
#include <stdio.h>

int make_socket(sndlen)
int sndlen;
{
  int s,fl;

  if((s = socket(AF_INET,SOCK_RAW,IPPROTO_RAW)) <0 )
    error("opening raw socket");

  /* This sets the data to allow for longer packets so that it will send it all at once
   * rather than break it up into multiple packets
   */

  if(setsockopt(s,SOL_SOCKET,SO_SNDBUF,(char *)&sndlen,sizeof(sndlen)))
    error("Unable to set socket options");

  fl = fcntl(s,F_GETFL,0);
  fl |= O_NONBLOCK;
  fcntl(s,F_SETFL,fl);

  return(s);
}
